struct vertex{
	float x, y, z;
	float nx, ny, nz;
};

#define MIRRORx 1
#define MIRRORy 2
#define MIRRORz 4

// void read_mtm_verticles(vertex verticles, int n){
// 	for(int i=1; i<=n; i++){
// 		fscanf(file, "%f %f %f %f %f %f\n", &verticles[i].x, &verticles[i].y, &verticles[i].z, &verticles[i].nx, &verticles[i].ny, &verticles[i].nz);
// 	}
// }

bool read_mtm(const char* filename, bool flat, short mirror){
	int n;
	FILE *file;
	if((file=fopen(filename, "r"))==NULL) return false;
	fscanf(file, "%d", &n);
	//printf("%d verticles:\n", n);
	vertex verticles[n+1];
	
	//read_mtm_verticles(&verticles, n);
	
	for(int i=1; i<=n; i++){
		fscanf(file, "%f %f %f %f %f %f\n", &verticles[i].x, &verticles[i].y, &verticles[i].z, &verticles[i].nx, &verticles[i].ny, &verticles[i].nz);
	}
	
	int mx=1, my=1, mz=1;
	if(mirror&MIRRORx) mx=-1;
	if(mirror&MIRRORy) my=-1;
	if(mirror&MIRRORz) mz=-1;
	
	float nx, ny, nz, tx, ty;
	int vId;
	int n2;
	
	fscanf(file, "%d", &n);
	for(int j=0; j<n; j++){
		fscanf(file, "%d", &n2);
		glBegin(GL_POLYGON);{
			fscanf(file, "%f %f %f", &nx, &ny, &nz);
			if(flat) glNormal3f(nx, ny, nz);
			for(int i=0; i<n2; i++){
				fscanf(file, "%f %f %d", &tx, &ty, &vId);
				if(!flat) glNormal3f(verticles[vId].nx, verticles[vId].ny, verticles[vId].nz);
				glTexCoord2f(tx, ty);
				glVertex3f(verticles[vId].x*mx, verticles[vId].y*my, verticles[vId].z*mz);
			}
		}glEnd();
	}
	return true;
}

GLuint load_mtm(const char* filename, bool flat, GLuint ID, short mirror){
	if(ID<=0) ID=glGenLists(1);
	glNewList(ID,GL_COMPILE);{
		if(!read_mtm(filename, flat, 1)) return 0;
	}glEndList(); 
	//printf("model loaded, on ID: %d\n", ID);
	return ID;
}
