

GLuint load_texture(const char* file, bool create){
	GLuint texture[1];
	
	SDL_Surface* surface = IMG_Load(file);
	if(create) glGenTextures(1, &texture[0]);
	glPixelStorei(GL_UNPACK_ALIGNMENT,4);
	glBindTexture(GL_TEXTURE_2D, texture[0]);
	SDL_PixelFormat *format = surface->format;
	if (format->Amask)
	{
		gluBuild2DMipmaps(GL_TEXTURE_2D, 4,
						  surface->w, surface->h, GL_RGBA,GL_UNSIGNED_BYTE, surface->pixels);
	}
	else
	{
		//glTexImage2D(GL_TEXTURE_2D, 1, 3, surface->w, surface->h, 0, GL_RGB, GL_UNSIGNED_BYTE, surface->pixels); 
		gluBuild2DMipmaps(GL_TEXTURE_2D, 3,
						  surface->w, surface->h, GL_RGB, GL_UNSIGNED_BYTE, surface->pixels);
	}
	glTexParameteri(GL_TEXTURE_2D,GL_TEXTURE_MIN_FILTER,GL_LINEAR_MIPMAP_LINEAR);
	glTexParameteri(GL_TEXTURE_2D,GL_TEXTURE_MAG_FILTER,GL_LINEAR_MIPMAP_LINEAR);
	SDL_FreeSurface(surface);
	printf("load %s on ID:%d\n", file, texture[0]);
	return texture[0];
}


void draw_box(float x1, float y1, float z1, float x2, float y2, float z2, float r, float g, float b){
	//glColor3f(0,1,0);
		glBegin(GL_QUADS);{//front
		glNormal3f( 0.0f, 0.0f, 1.0f);
		glColor3f(r,g,b);
		glVertex3f( x1, y1, z1);
		glVertex3f( x2, y1, z1);
		glVertex3f( x2, y2, z1);
		glVertex3f( x1, y2, z1);
	}glEnd();
	glBegin(GL_QUADS);{//top
		glNormal3f( 0.0f, 1.0f, 0.0f);
		glVertex3f( x1, y2, z1);
		glVertex3f( x2, y2, z1);
		glVertex3f( x2, y2, z2);
		glVertex3f( x1, y2, z2);
	}glEnd();
	glBegin(GL_QUADS);{//bottom
		glNormal3f( 0.0f, -1.0f, 0.0f);
		glVertex3f( x1, y1, z2);
		glVertex3f( x2, y1, z2);
		glVertex3f( x2, y1, z1);
		glVertex3f( x1, y1, z1);
	}glEnd();
	glBegin(GL_QUADS);{//right
		glNormal3f( 1.0f, 0.0f, 0.0f);
		glVertex3f( x2, y1, z2);
		glVertex3f( x2, y2, z2);
		glVertex3f( x2, y2, z1);
		glVertex3f( x2, y1, z1);
	}glEnd();
	glBegin(GL_QUADS);{//left
		glNormal3f( -1.0f, 0.0f, 0.0f);
		glVertex3f( x1, y1, z1);
		glVertex3f( x1, y2, z1);
		glVertex3f( x1, y2, z2);
		glVertex3f( x1, y1, z2);
	}glEnd();
	glBegin(GL_QUADS);{//back
		glNormal3f( 0.0f, 0.0f, -1.0f);
		glVertex3f( x1, y1, z2);
		glVertex3f( x2, y1, z2);
		glVertex3f( x2, y2, z2);
		glVertex3f( x1, y2, z2);
	}glEnd();
}
